Chris Sosa | a73ec16 | 2010-05-04 03:18:02 | [diff] [blame] | 1 | #!/bin/sh |
| 2 | |
Chris Sosa | a66f3a4 | 2012-05-18 02:12:58 | [diff] [blame] | 3 | # Copyright (c) 2012 The Chromium OS Authors. All rights reserved. |
Chris Sosa | a73ec16 | 2010-05-04 03:18:02 | [diff] [blame] | 4 | # Use of this source code is governed by a BSD-style license that can be |
| 5 | # found in the LICENSE file. |
| 6 | |
| 7 | # This scripts performs update of stateful partition directories useful for |
| 8 | # dev_mode. |
| 9 | |
Sonny Rao | 7e44ca2 | 2011-10-21 23:35:41 | [diff] [blame] | 10 | # in order to support developers going from older images with the old shflags |
| 11 | # we'll check for both new shflags and old shflags |
| 12 | if [ -f /usr/share/misc/shflags ] ; then |
| 13 | . /usr/share/misc/shflags |
| 14 | elif [ -f /usr/lib/shflags ] ; then |
| 15 | . /usr/lib/shflags |
| 16 | else |
| 17 | echo >&2 "$0 Unable to source shflags" |
| 18 | exit 1 |
| 19 | fi |
Chris Sosa | 1bf5637 | 2010-09-08 20:26:20 | [diff] [blame] | 20 | |
| 21 | # Constants for states. |
| 22 | CLEAN_STATE="clean" |
| 23 | OLD_STATE="old" |
Chris Sosa | a66f3a4 | 2012-05-18 02:12:58 | [diff] [blame] | 24 | RESET_STATE="reset" |
| 25 | |
| 26 | LSB_RELEASE="/etc/lsb-release" |
| 27 | STATEFUL_DIR="/mnt/stateful_partition" |
| 28 | UPDATE_STATE_FILE=".update_available" |
Chris Sosa | 1bf5637 | 2010-09-08 20:26:20 | [diff] [blame] | 29 | |
| 30 | DEFINE_string stateful_change "${OLD_STATE}" \ |
| 31 | "The state of the new stateful partition - used in update testing." |
| 32 | |
| 33 | FLAGS "$@" || exit 1 |
| 34 | |
Chris Sosa | a73ec16 | 2010-05-04 03:18:02 | [diff] [blame] | 35 | # Die on error. |
| 36 | set -e |
| 37 | |
Chris Sosa | ca4a925 | 2010-09-09 20:48:51 | [diff] [blame] | 38 | remove_quotes() { |
| 39 | echo "$1" | sed -e "s/^'//; s/'$//" |
| 40 | } |
| 41 | |
Chris Sosa | 1bf5637 | 2010-09-08 20:26:20 | [diff] [blame] | 42 | update_dev_image () { |
Chris Sosa | a66f3a4 | 2012-05-18 02:12:58 | [diff] [blame] | 43 | local base_update_url devserver_url |
Yu-Ju Hong | 120ceab | 2013-12-10 06:47:52 | [diff] [blame] | 44 | local local_payload_path |
| 45 | local path=$(remove_quotes "${FLAGS_ARGV}") |
| 46 | |
| 47 | if [ -z "${path}" ]; then |
Chris Sosa | 05491b1 | 2010-11-09 01:14:16 | [diff] [blame] | 48 | if [ -f "${STATEFUL_DIR}${LSB_RELEASE}" ]; then |
Chris Sosa | a66f3a4 | 2012-05-18 02:12:58 | [diff] [blame] | 49 | devserver_url=$(grep CHROMEOS_DEVSERVER ${STATEFUL_DIR}${LSB_RELEASE} | |
Chris Sosa | 8086c3f | 2011-03-05 00:30:36 | [diff] [blame] | 50 | cut -f 2 -d '=') |
Chris Sosa | 1bf5637 | 2010-09-08 20:26:20 | [diff] [blame] | 51 | fi |
Chris Sosa | a66f3a4 | 2012-05-18 02:12:58 | [diff] [blame] | 52 | if [ -z "${devserver_url}" ]; then |
| 53 | devserver_url=$(grep CHROMEOS_DEVSERVER ${LSB_RELEASE} | cut -f 2 -d '=') |
Chris Sosa | 1bf5637 | 2010-09-08 20:26:20 | [diff] [blame] | 54 | fi |
| 55 | # Sanity check. |
Chris Sosa | a66f3a4 | 2012-05-18 02:12:58 | [diff] [blame] | 56 | if [ -z "${devserver_url}" ]; then |
Yu-Ju Hong | 120ceab | 2013-12-10 06:47:52 | [diff] [blame] | 57 | echo >&2 "No CHROMEOS_DEVSERVER URL found in lsb-release file." |
Chris Sosa | 1bf5637 | 2010-09-08 20:26:20 | [diff] [blame] | 58 | exit 1 |
| 59 | fi |
| 60 | # Devserver URL should never contain "/update" |
Chris Sosa | a66f3a4 | 2012-05-18 02:12:58 | [diff] [blame] | 61 | devserver_url=$(echo ${devserver_url} | sed -e 's#/update##') |
| 62 | base_update_url="${devserver_url}/static" |
Yu-Ju Hong | 120ceab | 2013-12-10 06:47:52 | [diff] [blame] | 63 | # Determine whether the path is local. |
| 64 | elif [ -f "${path}" ] || [ "${path}" = "-" ]; then |
| 65 | local_payload_path=${path} |
| 66 | else |
| 67 | base_update_url=${path} |
Eric Li | 94a671e | 2010-08-03 00:58:50 | [diff] [blame] | 68 | fi |
Chris Sosa | 1bf5637 | 2010-09-08 20:26:20 | [diff] [blame] | 69 | |
Yu-Ju Hong | 120ceab | 2013-12-10 06:47:52 | [diff] [blame] | 70 | if [ -n "${base_update_url}" ]; then |
| 71 | local stateful_update_url="${base_update_url}/stateful.tgz" |
| 72 | echo >&2 "Downloading stateful payload from ${stateful_update_url}" |
| 73 | # Download and unzip directories onto the stateful partition. |
| 74 | eval "wget -qS -T 300 -O - \"${stateful_update_url}\"" | |
| 75 | tar --ignore-command-error --overwrite --directory=${STATEFUL_DIR} -xz |
| 76 | echo >&2 "Successfully downloaded update." |
| 77 | else |
| 78 | echo >&2 "Reading local payload ${local_payload_path}" |
| 79 | # Set timeout to two minutes to avoid waiting on stdin indefinitely. |
| 80 | timeout 120s tar --ignore-command-error --overwrite \ |
| 81 | --directory=${STATEFUL_DIR} -xzf ${local_payload_path} |
| 82 | echo >&2 "Successfully retrieved update." |
| 83 | fi |
Chris Sosa | 05491b1 | 2010-11-09 01:14:16 | [diff] [blame] | 84 | |
Chris Sosa | 8086c3f | 2011-03-05 00:30:36 | [diff] [blame] | 85 | if [ ! -d "${STATEFUL_DIR}/var_new" ] || |
| 86 | [ ! -d "${STATEFUL_DIR}/dev_image_new" ]; then |
| 87 | echo >&2 "Missing var or dev_image in stateful payload." |
| 88 | return 1 |
Eric Li | 94a671e | 2010-08-03 00:58:50 | [diff] [blame] | 89 | fi |
Chris Sosa | 1bf5637 | 2010-09-08 20:26:20 | [diff] [blame] | 90 | } |
| 91 | |
Chris Sosa | a66f3a4 | 2012-05-18 02:12:58 | [diff] [blame] | 92 | reset_state () { |
| 93 | echo >&2 "Resetting stateful update state." |
| 94 | rm -f "${STATEFUL_DIR}/${UPDATE_STATE_FILE}" |
| 95 | rm -rf "${STATEFUL_DIR}/var_new" |
| 96 | rm -rf "${STATEFUL_DIR}/dev_image_new" |
| 97 | } |
| 98 | |
Chris Sosa | 1bf5637 | 2010-09-08 20:26:20 | [diff] [blame] | 99 | update_old_state () { |
Chris Sosa | 05491b1 | 2010-11-09 01:14:16 | [diff] [blame] | 100 | echo >&2 "Performing standard stateful update." |
Chris Sosa | a66f3a4 | 2012-05-18 02:12:58 | [diff] [blame] | 101 | echo -n "" > "${STATEFUL_DIR}/${UPDATE_STATE_FILE}" |
Chris Sosa | 1bf5637 | 2010-09-08 20:26:20 | [diff] [blame] | 102 | } |
| 103 | |
| 104 | update_clean_state () { |
| 105 | echo >&2 "Restoring state to factory_install with dev_image." |
Chris Sosa | a66f3a4 | 2012-05-18 02:12:58 | [diff] [blame] | 106 | echo -n "clobber" > "${STATEFUL_DIR}/${UPDATE_STATE_FILE}" |
Chris Sosa | 1bf5637 | 2010-09-08 20:26:20 | [diff] [blame] | 107 | } |
| 108 | |
| 109 | main () { |
Chris Sosa | a66f3a4 | 2012-05-18 02:12:58 | [diff] [blame] | 110 | if [ "${FLAGS_stateful_change}" = "${RESET_STATE}" ]; then |
| 111 | reset_state |
| 112 | elif update_dev_image; then |
Chris Sosa | 8086c3f | 2011-03-05 00:30:36 | [diff] [blame] | 113 | if [ "${FLAGS_stateful_change}" = "${OLD_STATE}" ]; then |
| 114 | update_old_state |
| 115 | elif [ "${FLAGS_stateful_change}" = "${CLEAN_STATE}" ]; then |
| 116 | update_clean_state |
| 117 | else |
| 118 | echo >&2 "Invalid state given to stateful update. Aborting..." |
| 119 | return 1 |
| 120 | fi |
Chris Sosa | 1bf5637 | 2010-09-08 20:26:20 | [diff] [blame] | 121 | else |
Chris Sosa | 8086c3f | 2011-03-05 00:30:36 | [diff] [blame] | 122 | return 1 |
Eric Li | 94a671e | 2010-08-03 00:58:50 | [diff] [blame] | 123 | fi |
Chris Sosa | 1bf5637 | 2010-09-08 20:26:20 | [diff] [blame] | 124 | } |
Sean O'Connor | a7f867e | 2010-05-28 00:53:32 | [diff] [blame] | 125 | |
Chris Sosa | 1bf5637 | 2010-09-08 20:26:20 | [diff] [blame] | 126 | main $@ |